{    var   : }
{ EPS }
Unit MNB8R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNB8R(N :Integer; var X :Array of Real;
                var S :Array of Real; var XX :Array of Real;
                FUN :Proc_F1_MN; AA :Real; BB :Real; EPSX :Real;
                var EPS :Real; ITMAX :Integer; MAXK :Integer;
                var FMIN :Real; var XMIN :Real; var KOUNT :Integer;
                var ITER :Integer; NACC :Integer; var IER :Integer);

implementation

procedure MNB8R(N :Integer; var X :Array of Real;
                var S :Array of Real; var XX :Array of Real;
                FUN :Proc_F1_MN; AA :Real; BB :Real; EPSX :Real;
                var EPS :Real; ITMAX :Integer; MAXK :Integer;
                var FMIN :Real; var XMIN :Real; var KOUNT :Integer;
                var ITER :Integer; NACC :Integer; var IER :Integer);
var
L,I1,IX,ISW,I :Integer;
T1,A,B :Real;
FN :Array [0..1] of Real;
C :Array [0..1] of Real;
V :Array [0..1] of Real;
const
C1 :Real = -2.078086;
ZERO :Real = 0.0;
label
_105,_107,_110,_111,_112,_113,_114,_115,_120,_125,_127,_128,_130,_132,
_133,_135,_137,_140,_150,_160,_1000;
begin
{   DATA  FORTRAN  }
C[0] := 0.381966011;
C[1] := 0.618033989;
{      -------------------------------------------------- }
{     OHOMEPHA MHMA YK MHOX EPEMEHHX }
{     O AAHHOMY HAPABEH  HA AAHHOM HTEPBAE }
{     METOOM 'OOTOO CEEH' }

{     APAMETP: }
{     N     -PAMEPHOCT POCTPAHCTBA EPEMEHHX }
{     X     -HAAHA TOKA OCKA }
{     S     -BEKTOP H N - HAPABEHE OCKA }
{     XX    -PAO BEKTOP H N }
{     FUN   -M OPOPAMM BCEH YHK }
{     AA    -HH PAHA HTEPBAA, COEPAEO }
{           MHMYM }
{     BB    -BEPXH PAHA HTEPBAA }
{     EPSX  -TOHOCT BCEH TOK MHMYMA O }
{           APYMEHTY (KOHEH HTEPBA) }
{     EPS   -TOHOCT BCEH MHMYMA O YHKOHAY }
{     ITMAX -MAKCMAHOE CO TEPA }
{     MAXK  -MAKCMAHOE CO BCEH YHK }
{     FMIN  -BCEHHOE MHMAHOE HAEHE YHK }
{     XMIN  -PACCTOHE OT X O BCEHHO TOK }
{           MHMYMA BO S }
{     KOUNT -BOHEHHOE CO BCEH YHK }
{     ITER  -BOHEHHOE CO TEPA }
{     NACC  -PHAK BAPAHTA AOPTMA: }
{            NACC=1-HA KAO TEPA BCETC }
{                  TOKO OHA KOHTPOHA TOKA }
{            NACC=2-BCTC OE TOK }
{     IER   -PHAK OKOHAH POECCA: }
{            IER= 1-OCTHYTA TOHOCT EPS }
{            IER= 2-OCTHYTA TOHOCT EPSX }
{            IER=65-AAHH EPSX.LE.0 }
{            IER=66-EC (BB-AA).LE.0.OR.EPSX.GT.(BB-AA) }
{            IER=67-BOHEHO ITMAX TEPA }
{            IER=68-BOHEHO MAXK BCEH YHK }
{      -------------------------------------------------- }

{ ---------- }
{      ***MAHOABCME KOHCTAHT** }


ITER := 0;
IER := 0;
KOUNT := 0;
if ( EPSX > ZERO ) 
 then goto _105;
{ ---------- }
{      ***COOEHE, TO KOHEH HTEPBA*** }
{         MEHE  PABEH HY }

IER := 65;
goto _1000;
_105:
T1 := BB-AA;
if ( T1 > ZERO ) and ( T1 >= EPSX ) 
 then goto _107;
{ ---------- }
{      ***COOEHE, TO HAAH HTEBA HE*** }
{         OOTEH  TO KOHEH HTEPBA }
{         OE EM HAAH }

IER := 66;
goto _1000;
_107:
A := AA;
B := BB;
_110:
V[1] := C[1]*(B-A)+A;
for L:=1 to N do
 begin
  XX[L-1] := X[L-1]+V[1]*S[L-1];
_111:
 end;
FUN(XX,FN[1],EPS);
KOUNT := KOUNT+1;
I1 := Trunc( C1*Ln(EPSX/(B-A))+1 );
IX := 1;
{ ---------- }
{      ***HAAHM HTEPBAOM BETC (A,B)*** }
{         V(1)  V(2)-KOHTPOHE TOK }

ISW := 0;
for I:=1 to I1 do
 begin
  ITER := ITER+1;
  if ( ITER <= ITMAX ) 
   then goto _112;
{ ---------- }
{      ***BOHEHO ITMAX TEPA }

  IER := 67;
  goto _140;
_112:
  V[IX-1] := C[IX-1]*(B-A)+A;
  for L:=1 to N do
   begin
    XX[L-1] := X[L-1]+V[IX-1]*S[L-1];
_113:
   end;
  FUN(XX,FN[IX-1],EPS);
  KOUNT := KOUNT+1;
  if ( KOUNT <= MAXK ) 
   then goto _114;
{ ---------- }
{      ***BOHEHO MAXK BCEH YHK }

  IER := 68;
  goto _140;
_114:
{ ---------- }
{      ***EC HTEPBA OTEPH, TO BOCCTAHOBEHE }

  if ( V[1] <= V[0] ) 
   then goto _110;
  if ( Abs(FN[0]-FN[1]) > EPS*EMax1(Abs(FN[0]),
       Abs(FN[1])) ) 
   then goto _120;
  if ( ISW <> 0 ) 
   then goto _115;
  ISW := 1;
  goto _125;

{      ***OCTHYTA TOHOCT O YHKOHAY }

_115:
  IER := 1;
  goto _140;
_120:
  ISW := 0;
_125:
  if ( FN[0] <  FN[1] ) 
   then goto _130;
  IX := 2;
  A := V[0];

{      ***CTAP V(2) CTAHOBTC HOBM V(1)*** }

  V[0] := V[1];
  FN[0] := FN[1];
  if ( Abs(B-A) > EPSX ) 
   then goto _127;
  IER := 2;
  goto _140;
_127:
  if ( NACC < 2 ) 
   then goto _135;
  V[0] := C[0]*(B-A)+A;
  for L:=1 to N do
   begin
_128:
    XX[L-1] := X[L-1]+V[0]*S[L-1];
   end;
  FUN(XX,FN[0],EPS);
  KOUNT := KOUNT+1;
  goto _135;
_130:
  IX := 1;
  B := V[1];

{      ***CTAP V(1) CTAHOBTC HOBM V(2)*** }

  V[1] := V[0];
  FN[1] := FN[0];
  if ( Abs(B-A) > EPSX ) 
   then goto _132;
  IER := 2;
  goto _140;
_132:
  if ( NACC < 2 ) 
   then goto _135;
  V[1] := C[1]*(B-A)+A;
  for L:=1 to N do
   begin
_133:
    XX[L-1] := X[L-1]+V[1]*S[L-1];
   end;
  FUN(XX,FN[1],EPS);
  KOUNT := KOUNT+1;
_135:
_137:
 end;
goto _110;
{ ---------- }
{      ***OKOHAHE OCKA. OPEEEHE }
{         BXOHX APAMETPOB }

_140:
if ( FN[1]-FN[0] ) < 0
 then goto _150
 else if ( FN[1]-FN[0] ) > 0
       then goto _160
       else goto _150;
_150:
FMIN := FN[1];
XMIN := V[1];
goto _1000;
_160:
FMIN := FN[0];
XMIN := V[0];
_1000:
end;

end.
